package com.caimei365.manager.service.sys;

import com.caimei365.manager.entity.PaginationVo;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.entity.sys.SysMenu;

import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2022/1/6
 */
public interface SysMenuService {
    /**
     * 获取菜单列表
     * @param parentId 父级菜单Id
     * @param status   状态：0启用，1停用
     * @param pageNum  页码
     * @param pageSize 每页大小
     */
    ResponseJson<PaginationVo<SysMenu>> getMenuList(Integer parentId, Integer status, int pageNum, int pageSize);
    /**
     * 获取所有启用的菜单列表（树状结构返回）
     */
    ResponseJson<List<SysMenu>> getMenuTree();
    /**
     * 根据ID获取菜单
     */
    ResponseJson<SysMenu> getMenu(Integer id);
    /**
     * 根据ID更新菜单
     */
    ResponseJson<Void> updateMenu(Integer id, SysMenu menu);
    /**
     * 根据ID(可选择的)更新菜单字段
     */
    ResponseJson<Void> updateMenuSelective(Integer id, SysMenu menu);
    /**
     * 添加菜单
     */
    ResponseJson<Void> addMenu(SysMenu menu);
    /**
     * 根据ID删除菜单
     */
    ResponseJson<Void> deleteMenu(Integer id);
}
